l( "Core draw library" , "load" );

var draw = {

	rectangle : function ( mode , x , y , w , h , colour ) {
		switch ( mode ) {
			case "line":
				context.strokeStyle = colour;

				context.strokeRect( x , y , w , h );
				break;

			case "fill":
        context.strokeStyle = "#000";
				context.fillStyle = colour;

        context.fillRect( x , y , w , h );
        context.strokeRect( x , y , w , h );
				break;

			default:
				console.error( "Invalid mode '" + mode + "'" );
		}
	},

	circle : function ( mode , x , y , r , colour ) {
		switch ( mode ) {
			case "line":
				context.strokeStyle = colour;

				context.beginPath();
				context.arc( x , y , r , 0 , 2*Math.PI );
				context.stroke();
				context.closePath();
				break;

			case "fill":
				context.fillStyle = colour;
        context.strokeStyle = "#000";

				context.beginPath();
				context.arc( x , y , r , 0 , 2*Math.PI );
				context.stroke();
				context.fill();
				context.closePath();
				break;

			default:
				console.error( "Invalid mode '" + mode + "'" );
		}
	},

  line : function ( x1 , y1 , x2 , y2 , colour ) {
    context.strokeStyle = colour;

    context.beginPath();
    context.moveTo(x1, y1);
    context.lineTo(x2, y2);
    context.stroke();
    context.closePath();
  },

  vector : function( x , y , v , colour ) {
    draw.line( x , y , x+(v.x) , y+(v.y) , colour )
  },

	image : function ( img , x , y ) {
		context.drawImage( img , x , y );
	},

}
