//Log function
function l( msg , kind ) {
	switch ( kind ) {
		case "load":
			console.log( "Loading: " + msg );
			break;

		case "loadAssets":
			console.log( "Loading assets: " + msg );
			break;

		case "major":
			console.log( "====" + msg + "====" );
			break;

		default:
			console.log( msg );
	}
}

// function l() {}

l( "Core initialisation" , "load" );

//Initialisation
var lastStamp = 0;

var canvas = document.createElement( "canvas" );
var context = canvas.getContext("2d");

var width  = 260 //600
var height = 600

var game = {};
var asset = {};

//Additional random functions
function randInt(a,b) {
	if (b) {
		b++;
	} else {
		b = a
		a = 1
	}
	return a + Math.floor(Math.random() * b )
}

Array.prototype.random = function () {
    return this[Math.floor(Math.random() * this.length)]
		// return this[randInt(0,this.length-1)]
}

//Load asset functions
function loadImages( category , dir , files ) {
	l( category + " (" + dir + ")" , "loadAssets" );

	if ( !asset[category] ) {
		asset[category] = {};
	}

	var imgName;
	files.forEach( function ( v , k ) {
		l( dir + "/" + v );

		imgName = v;
		while ( imgName[imgName.length-1] != "." ) {
		    imgName = imgName.slice( 0 , imgName.length-1 );
		}
		imgName = imgName.slice( 0 , imgName.length-1 );

		asset[category][imgName] = new Image;
		asset[category][imgName].src = "assets/" + dir + "/" + v;
	});
}

//function loadSound(s?)

//Input handling
var isKeyDown = {}
window.addEventListener( "keydown", function ( event ) {
  isKeyDown[ event.key ] = true;
  if([32, 37, 38, 39, 40].indexOf(event.keyCode) > -1) {
        event.preventDefault();
    }
  if ( !event.repeat ) {
    gameKeyPressed( event.key.toLowerCase() );
  }
});

window.addEventListener( "keyup", function ( event ) {
  isKeyDown[ event.key ] = false;
	if ( !event.repeat ) {
    gameKeyUnpressed( event.key.toLowerCase() );
  }
});

window.addEventListener( "mousedown" , function (event) {
  var x = event.pageX - canvas.offsetLeft;
  var y = event.pageY - canvas.offsetTop;

  gameMousePressed( event.button , x , y )
}, false);

window.addEventListener( "mouseup" , function (event) {
  var x = event.pageX - canvas.offsetLeft;
  var y = event.pageY - canvas.offsetTop;

  gameMouseReleased( event.button , x , y )
}, false);

window.addEventListener( "mousemove" , function (event) {
  var x = event.pageX - canvas.offsetLeft;
  var y = event.pageY - canvas.offsetTop;

  gameMouseMoved( x , y )
}, false);
